package boot.common.config;

import com.alibaba.druid.pool.DruidDataSource;
import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.autoconfigure.SpringBootVFS;
import com.baomidou.mybatisplus.extension.plugins.MybatisPlusInterceptor;
import com.baomidou.mybatisplus.extension.plugins.inner.PaginationInnerInterceptor;
import com.baomidou.mybatisplus.extension.spring.MybatisSqlSessionFactoryBean;
import org.apache.ibatis.io.VFS;
import org.apache.ibatis.plugin.Interceptor;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.DefaultResourceLoader;

import javax.sql.DataSource;
@Configuration
@MapperScan(basePackages ={"boot.modules.*.mapper", "boot.config"})
public class MybatisPlusConfig {

    @Autowired
    MybatisPlusInterceptor paginationInnerInterceptor;
    @ConfigurationProperties(prefix = "spring.datasource")
    @Bean
    public DruidDataSource druidDataSource(){
//        druidDataSource.setUrl("jdbc:mysql://localhost:3306/test?serverTimezone=GMT%2B8&useUnicode=true&characterEncoding=UTF-8");
//        druidDataSource.setUsername("root");
//        druidDataSource.setPassword("273672");
        return new DruidDataSource();
    }

    // 调整 SqlSessionFactory 为 Mybatis-Plus 的 MybatisSqlSessionFactoryBean
    @Bean
    MybatisSqlSessionFactoryBean bean(DataSource dataSource) {
        MybatisSqlSessionFactoryBean bean = new MybatisSqlSessionFactoryBean();
        bean.setDataSource(dataSource);
        // 设置映射文件路径
//        bean.setMapperLocations(new ClassPathResource("mapper/sys/ExampleUserMapper.xml"));
        // 设置分页插件
        bean.setPlugins(paginationInnerInterceptor);
        return bean;
    }

    /**
     * myBatisPlus 分页插件
     */
    @Bean
    public MybatisPlusInterceptor mybatisPlusInterceptor() {
        MybatisPlusInterceptor mybatisPlusInterceptor = new MybatisPlusInterceptor();
        mybatisPlusInterceptor.addInnerInterceptor(new PaginationInnerInterceptor(DbType.MYSQL));
        return mybatisPlusInterceptor;
    }
}

//@Configuration
//public class MybatisPlusConfig {
//    @Autowired
//    private Environment env;
//    /**
//     * mybatis-plus分页插件
//     */
//    @Bean
//    public MybatisPlusInterceptor paginationInterceptor() {
//        MybatisPlusInterceptor interceptor = new MybatisPlusInterceptor();
//        //添加MySQL的分页拦截器
//        interceptor.addInnerInterceptor(new PaginationInnerInterceptor(DbType.MYSQL));
//        return interceptor;
//    }
//
//    @Bean
//    public SqlSessionFactory sqlSessionFactory(DataSource dataSource) throws Exception {
//        String typeAliasesPackage = env.getProperty("mybatis-plus.typeAliasesPackage");
////        String mapperLocations = env.getProperty("mybatis-plus.mapperLocations");
//        String configLocation = env.getProperty("mybatis-plus.configLocation");
////        typeAliasesPackage = setTypeAliasesPackage(typeAliasesPackage);
//        VFS.addImplClass(SpringBootVFS.class);
//        final MybatisSqlSessionFactoryBean sessionFactory = new MybatisSqlSessionFactoryBean ();
//        sessionFactory.setDataSource(dataSource);
////        sessionFactory.setGlobalConfig(globalConfiguration());
//        sessionFactory.setTypeAliasesPackage(typeAliasesPackage);
////        sessionFactory.setMapperLocations(resolveMapperLocations(StringUtils.split(mapperLocations, ",")));
//        sessionFactory.setConfigLocation(new DefaultResourceLoader().getResource(configLocation));
//        sessionFactory.setPlugins(paginationInterceptor());
//        return sessionFactory.getObject();
//    }
//
//}
