// 引入Vue
import { createApp } from 'vue'
// 引入App组件
import App from './App.vue'
// 引入路由
import router from './router'
// 引入element-plus插件
import ElementPlus from 'element-plus'
// 引入element-plus样式
import 'element-plus/theme-chalk/index.css'
// 引入pinia
import pinia from './stores'  ;//引入

// 解决 Vue自带的编译时标志报错
window.__VUE_PROD_DEVTOOLS__ = false;
// 在生产环境中启用/禁用开发者工具支持。启用会在打包结果中包含更多代码

window.__VUE_PROD_HYDRATION_MISMATCH_DETAILS__ = false;
// 启用/禁用生产环境构建下激活 (hydration) 不匹配的详细警告。启用会在打包结果中包含更多代码

const app = createApp(App)
app.use(router).use(pinia).use(ElementPlus).mount('#app')
