import { createRouter, createWebHistory } from 'vue-router'
import { staticRoutes } from "./router";
import { ElMessage } from 'element-plus';
import Cookies from 'js-cookie'

// 创建并保留路由器
const router = createRouter({
  history: createWebHistory(),
  routes: staticRoutes
})

router.beforeEach((to, from, next) => {
  const TokenKey = 'vue_admin_template_token'
  const token = Cookies.get(TokenKey)
  if (to.meta.isAuth) {
    if (token) {
      next()
      return
    }
    else {
      ElMessage.error("尚未登录,请先登录")
    }
    next("/login")
    return
  }
  if (to.matched.length === 0) {
    ElMessage.error("无效页面,自动返回首页")
    next("/index")
  }
  next()
});

//全局前置路由守卫
export default router
